# Hides everything in the scene except the currently selected figure and
# its attachments and clothing.

import poser
scene=poser.Scene()
NoHide=scene.CurrentActor()
TheFig=NoHide.ItsFigure()
if not TheFig: raise "No Figure"
AlreadyUsed=[]
AlreadyUsed.append(TheFig.Name())

# Run figures:
for OneFig in scene.Figures():
    if OneFig.Name() in AlreadyUsed: # Leave the selected fig visible
        continue
    # Leave conformed clothing visible:
    elif (OneFig.ConformTarget() != None) and (OneFig.ConformTarget().Name() in AlreadyUsed):
        AlreadyUsed.append(OneFig.Name())
        continue
    else: # A figure that isn't the selected nor any of its conformed figs
        for A in OneFig.Actors():
            A.SetVisible(0) # Hide.

# now run props that aren't body parts:
for A in scene.Actors():
    if A.ItsFigure() != None: # Tied to a figure, check:
        if A.ItsFigure().Name() not in AlreadyUsed: # If not to the main, hide.
            A.SetVisible(0)
    else: # Outside of any figure, definitely hide.
        A.SetVisible(0)

